//
//  trie.c
//
//  Created by Julien-Pierre Avrous on 22/08/06.
//  Copyright 2006 SourceMac.com. All rights reserved.
//
//

#include <stdlib.h>
#include "trie.h"

void Insert(int x, int len, int tb[]);

void TrieBulle(int tb[], int sz)
{
	register int i, j, ech;
	
	for(i=0;i<sz;i++)
		for(j=i+1;j<=sz;j++)
			if(tb[j]<tb[i])
				{
				ech=tb[j];
				tb[j]=tb[i];
				tb[i]=ech;
				}
}

void TrieSelection(int tb[], int sz)
{
	register int i, j, posmin;
	register int ech;
  
	for(i=0; i<sz; i++)
		{
		posmin=i;
		for(j=i+1; j<=sz; j++)
			{
			if(tb[j]<tb[posmin])
				posmin=j;
			}
		ech=tb[i];
		tb[i]=tb[posmin];
		tb[posmin]=ech;
		}
}

void TrieInsertion(int tb[], int sz)
{
	register int i;
	int *res;
	
	res=(int *)malloc(sz*sizeof(int));
	res[0]=tb[0];
	for(i=1; i<=sz; i++)
		Insert(tb[i], i-1, res);

	for(i=0; i<=sz; i++)
		tb[i]=res[i];
		
	free(res);
 }
 
 
void Insert(int x, int len, int tb[])
{
	register int i=0, j;
	
	while( (i<=len) && (x>tb[i]) )
		i++;
   
	for(j=len; j>=i; j--)
		tb[j+1]=tb[j];
		
	tb[i]=x;
}